/**
 * about:bookmarkshome handler
 * (c) 2005 Myen adapted by Jeroen Groenenboom and jean-bernard marcon
 * based on kitchensink, Mozilla's nsAboutRedirector.cpp and related files
 * License: MPL
 */

function aboutBookmarkshome(){
}

aboutBookmarkshome.prototype = {

getK_URI: function( aboutURL ) { 
	      try {
		  var bmhDynamic = true;
		  var chromeURL = "chrome://bookmarkshome/content/";
		  var what = aboutURL.replace( /^about:/, "" ).toLowerCase();
		  var dynamicURL = chromeURL + "bookmarksHome.html";
		  var staticURL = chromeURL + what + "Saved.html";
		  var binCheck = 1 << ( parseInt( what.match( /\w$/ )) || 0 ) ;
		  var branch = Components.classes["@mozilla.org/preferences-service;1"]
		      .getService( Components.interfaces.nsIPrefService )
		      .getBranch( "bookmarkshome." );
		  var result = branch.getIntPref( "dynamics" ) & binCheck;
		  if( ! ( branch.getIntPref( "dynamics" ) & binCheck )) {  
		      // check if static page exists
		      var  bmhStaticLoc = Components.classes["@mozilla.org/network/standard-url;1"]
			  .createInstance( Components.interfaces.nsIURL );
		      bmhStaticLoc.spec = staticURL;
		      var  chromeReg = Components.classes["@mozilla.org/chrome/chrome-registry;1"]
			  .getService( Components.interfaces.nsIChromeRegistry );
		      // convert chrome url to file url 
		      var fileURL = chromeReg.convertChromeURL( bmhStaticLoc );
		      if( fileURL instanceof Components.interfaces.nsIURI ) {
			  // deerpark
			  fileURL = fileURL.spec;
		      }
		      // get file from url
		      var bmhFile = Components.classes["@mozilla.org/network/protocol;1?name=file"]
			  .createInstance( Components.interfaces.nsIFileProtocolHandler )
			  .getFileFromURLSpec( fileURL );
		      if( bmhFile.exists() ) {
			  bmhDynamic = false;
		      }
		  }
	      }
	      catch( e ) {
		  dump( e );
	      }
	      return ( bmhDynamic ? dynamicURL : staticURL );
	  },

	  /* nsIAboutModule */
	  /* nsIChannel newChannel(in nsIURI aURI); */
newChannel: function ( aURI ) {
		var ex;
		// sanity check
		aURI = aURI.QueryInterface( Components.interfaces['nsIURI'] );

		var ioService = Components.classes['@mozilla.org/network/io-service;1']
		    .getService( Components.interfaces['nsIIOService'] );
		var tempChannel = ioService.newChannel( this.getK_URI( aURI.spec ), null, null );

		try {
		    tempChannel.setOriginalURI(aURI);
		} 
		catch ( ex ) {
		    // exception ignored
		}

		// XXX Mook: I have tested this, and the resulting channel does not appear
		// to have chrome privileges.  

		return tempChannel;
	    },

	    /* nsISupports */
QueryInterface: function (aIID) {
		    var interfaces = [
			'nsISupports',
		    'nsIAboutModule'
			];
		    for( var index in interfaces ) {
			if ( aIID.equals( Components.interfaces[interfaces[index]] ))
			    return this;
		    }
		    throw this.C_RESULTS['NS_ERROR_NO_INTERFACE'];
		}
}


